## wpa 2.10-21ubuntu0.3trisquel1

=== debian/changelog ===
wpa (2:2.10-21ubuntu0.3trisquel1) ecne; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 02 Oct 2025 18:51:12 +0000

wpa (2:2.10-21ubuntu0.3) noble; urgency=medium

  * Bump DEFAULT_BSS_MAX_COUNT to 1000 (LP: #2117180)

 -- Mitchell Augustin <mitchell.augustin@canonical.com>  Mon, 21 Jul 2025 18:13:31 -0500

=== debian/control ===
Source: wpa
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
XSBC-Original-Maintainer: Debian wpasupplicant Maintainers <wpa@packages.debian.org>
Uploaders:
 Andrej Shadura <andrewsh@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13),
 libdbus-1-dev,
 libssl-dev,
 qtbase5-dev [linux-any] <!pkg.wpa.nogui>,
 libncurses5-dev,
 libpcsclite-dev,
 libnl-3-dev [linux-any],
 libnl-genl-3-dev [linux-any],
 libnl-route-3-dev [linux-any],
 libpcap-dev [kfreebsd-any],
 libbsd-dev [kfreebsd-any],
 libreadline-dev,
 pkgconf | pkg-config,
 docbook-to-man <!nodoc>,
 docbook-utils <!nodoc>,
Standards-Version: 4.4.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/wpa
Vcs-Git: https://salsa.debian.org/debian/wpa.git
Homepage: https://w1.fi/wpa_supplicant/

Package: hostapd
Architecture: linux-any kfreebsd-any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends},
Description: access point and authentication server for Wi-Fi and Ethernet
 IEEE 802.11 AP and IEEE 802.1X/WPA/WPA2/WPA3/EAP Authenticator
 .
 Originally, hostapd was an optional user space component for Host AP
 driver. It adds more features to the basic IEEE 802.11 management
 included in the kernel driver: using external RADIUS authentication
 server for MAC address based access control, IEEE 802.1X Authenticator
 and dynamic WEP keying, RADIUS accounting, WPA/WPA2/WPA3 (IEEE 802.11i/RSN)
 Authenticator and dynamic TKIP/CCMP keying.
 .
 The current version includes support for other drivers, an integrated
 EAP authenticator (i.e., allow full authentication without requiring
 an external RADIUS authentication server), and RADIUS authentication
 server for EAP authentication.
 .
 hostapd works with the following drivers:
 .
  * mac80211 based drivers with support for master mode [linux]
  * Host AP driver for Prism2/2.5/3 [linux]
  * Driver interface for FreeBSD net80211 layer [kfreebsd]
  * Any wired Ethernet driver for wired IEEE 802.1X authentication.

Package: wpagui
Architecture: linux-any
Build-Profiles: <!pkg.wpa.nogui>
Multi-Arch: foreign
Depends: ${shlibs:Depends},
 ${misc:Depends},
 wpasupplicant,
 libqt5svg5
Description: graphical user interface for wpa_supplicant
 wpagui provides a Qt interface for choosing which configured network
 to connect to. It also provides a method for browsing 802.11 SSID scan
 results, an event history log of messages generated by wpa_supplicant,
 and a method to add or edit wpa_supplicant networks.

Package: wpasupplicant
Architecture: linux-any kfreebsd-any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
 ${misc:Depends},
 adduser
Breaks: network-manager (<< 1.36.4-2~)
Suggests: wpagui,
 libengine-pkcs11-openssl
Description: client support for WPA and WPA2 (IEEE 802.11i)
 wpa-supplicant is a userspace daemon handling connection and authentication
 in wireless and wired networks, primarily secured with the WPA/WPA2/WPA3
 protocols. This software provides key negotiation with the access point
 (WPA Authenticator), and controls association with IEEE 802.11i networks.

Package: wpasupplicant-udeb
Architecture: linux-any
Build-Profiles: <!noudeb>
Section: debian-installer
Priority: standard
Depends: ${shlibs:Depends},
 ${misc:Depends},
 busybox-udeb
Package-Type: udeb
Description: client support for WPA and WPA2 (IEEE 802.11i)
 wpa-supplicant is a userspace daemon handling connection and authentication
 in wireless and wired networks, primarily secured with the WPA/WPA2/WPA3
 protocols. This software provides key negotiation with the access point
 (WPA Authenticator), and controls association with IEEE 802.11i networks.
 .
 This is a udeb of wpasupplicant for use by the debian-installer.

Package: eapoltest
Architecture: linux-any kfreebsd-any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: EAPoL testing utility
 eapol_test allows testing EAP authentication methods without using
 a full 802.1X connection. It is frequently used to test the EAP
 configuration of RADIUS systems. It is an administrator tool and not
 required for standard 802.1X authentication.

Package: libwpa-client-dev
Section: libdevel
Architecture: linux-any kfreebsd-any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libwpa-dev
Breaks: libwpa-dev
Description: development files for WPA/WPA2 client support (IEEE 802.11i)
 wpa-supplicant is a userspace daemon handling connection and authentication
 in wireless and wired networks, primarily secured with the WPA/WPA2/WPA3
 protocols. This software provides key negotiation with the access point
 (WPA Authenticator), and controls association with IEEE 802.11i networks.
 .
 This package contains static libwpa_client library and header files.

## wpa 2.11

=== src/crypto/Makefile ===
CFLAGS += -DCONFIG_CRYPTO_INTERNAL
CFLAGS += -DCONFIG_TLS_INTERNAL_CLIENT
CFLAGS += -DCONFIG_TLS_INTERNAL_SERVER
#CFLAGS += -DALL_DH_GROUPS
CFLAGS += -DCONFIG_SHA256
CFLAGS += -DCONFIG_SHA384
CFLAGS += -DCONFIG_HMAC_SHA384_KDF
CFLAGS += -DCONFIG_INTERNAL_SHA384

LIB_OBJS= \
	aes-cbc.o \
	aes-ccm.o \
	aes-ctr.o \
	aes-eax.o \
	aes-encblock.o \
	aes-gcm.o \
	aes-internal.o \
	aes-internal-dec.o \
	aes-internal-enc.o \
	aes-omac1.o \
	aes-siv.o \
	aes-unwrap.o \
	aes-wrap.o \
	des-internal.o \
	dh_group5.o \
	dh_groups.o \
	md4-internal.o \
	md5.o \
	md5-internal.o \
	milenage.o \
	ms_funcs.o \
	rc4.o \
	sha1.o \
	sha1-internal.o \
	sha1-pbkdf2.o \
	sha1-prf.o \
	sha1-tlsprf.o \
	sha1-tprf.o \
	sha256.o \
	sha256-prf.o \
	sha256-tlsprf.o \
	sha256-internal.o \
	sha384.o \
	sha384-prf.o \
	sha384-internal.o \
	sha512.o \
	sha512-prf.o \
	sha512-internal.o

LIB_OBJS += crypto_internal.o
LIB_OBJS += crypto_internal-cipher.o
LIB_OBJS += crypto_internal-modexp.o
LIB_OBJS += crypto_internal-rsa.o
LIB_OBJS += tls_internal.o
LIB_OBJS += fips_prf_internal.o
ifndef TEST_FUZZ
LIB_OBJS += random.o
endif

include ../lib.rules

=== src/eap_server/Makefile ===
CFLAGS += -DCONFIG_HS20

LIB_OBJS= \
	eap_server.o \
	eap_server_identity.o \
	eap_server_methods.o

include ../lib.rules

=== src/tls/Makefile ===
CFLAGS += -DCONFIG_INTERNAL_LIBTOMMATH
CFLAGS += -DCONFIG_CRYPTO_INTERNAL
CFLAGS += -DCONFIG_TLSV11
CFLAGS += -DCONFIG_TLSV12

LIB_OBJS= \
	asn1.o \
	bignum.o \
	pkcs1.o \
	pkcs5.o \
	pkcs8.o \
	rsa.o \
	tlsv1_client.o \
	tlsv1_client_read.o \
	tlsv1_client_write.o \
	tlsv1_client_ocsp.o \
	tlsv1_common.o \
	tlsv1_cred.o \
	tlsv1_record.o \
	tlsv1_server.o \
	tlsv1_server_read.o \
	tlsv1_server_write.o \
	x509v3.o

include ../lib.rules

=== wpa_supplicant/dbus/Makefile ===
all: libwpadbus.a

clean:
	rm -f *~ *.o *.d *.gcno *.gcda *.gcov
	rm -f libwpadbus.a

install:
	@echo Nothing to be made.

ifndef CC
CC=gcc
endif

ifndef CFLAGS
CFLAGS = -MMD -O2 -Wall -g
endif

PKG_CONFIG ?= pkg-config
CFLAGS += -I../../src -I../../src/utils


Q=@
E=echo
ifeq ($(V), 1)
Q=
E=true
endif

%.o: %.c
	$(Q)$(CC) -c -o $@ $(CFLAGS) $<
	@$(E) "  CC " $<


ifdef CONFIG_WPS
CFLAGS += -DCONFIG_WPS
endif

CFLAGS += -DCONFIG_CTRL_IFACE_DBUS_NEW

ifndef DBUS_LIBS
DBUS_LIBS := $(shell $(PKG_CONFIG) --libs dbus-1)
endif
ifndef DBUS_INCLUDE
DBUS_INCLUDE := $(shell $(PKG_CONFIG) --cflags dbus-1)
endif
ifdef CONFIG_CTRL_IFACE_DBUS_INTRO
CFLAGS += -DCONFIG_CTRL_IFACE_DBUS_INTRO
DBUS_INCLUDE += $(shell xml2-config --cflags)
DBUS_LIBS += $(shell xml2-config --libs)
endif

CFLAGS += $(DBUS_INCLUDE)

LIB_OBJS= \
	dbus_common.o \
	dbus_new.o \
	dbus_new_handlers.o \
	dbus_new_helpers.o \
	dbus_new_introspect.o \
	dbus_dict_helpers.o

ifdef CONFIG_WPS
LIB_OBJS += dbus_new_handlers_wps.o
endif

libwpadbus.a: $(LIB_OBJS)
	$(AR) crT $@ $?

-include $(OBJS:%.o=%.d)

=== debian/changelog ===
wpa (2:2.11-2) experimental; urgency=medium

  * Remove deprecated symbolic link to /usr/share/doc/wpa_supplicant
    (Closes: #1103299).
  * Start hostapd@ after the device exists (Closes: #923461).
  * No longer log to syslog when being run by systemd (Closes: #925153).
  * Remove misleading wpa_cli usage comment (Closes: #819229).
  * Build and install nt_password_hash and sae_pk_gen (Closes: #1065209).
  * Sync defconfig.
  * Enable CONFIG_SAE_PK and CONFIG_IEEE80211AX.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 16 Feb 2026 18:04:00 +0100

wpa (2:2.11-1) experimental; urgency=medium

  [ Andrej Shadura ]
  * New upstream release.
  * Set up gbp.conf for experimental.
  * Refresh patches.
  * Remove kFreeBSD support: no longer developed in Debian.

  [ Rob Shearman ]
  * debian/watch: Fix Git server and protocol.
  * debian/control: Remove mentions of kfreebsd-any.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 16 Feb 2026 14:12:09 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: wpa
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
-XSBC-Original-Maintainer: Debian wpasupplicant Maintainers <wpa@packages.debian.org>
+Maintainer: Debian Networking Team <team+networking@tracker.debian.org>
 Uploaders:
  Andrej Shadura <andrewsh@debian.org>
 Section: net
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+ dh-sequence-installsysusers,
  libdbus-1-dev,
  libssl-dev,
  qtbase5-dev [linux-any] <!pkg.wpa.nogui>,
@@ -14,8 +14,6 @@
  libnl-3-dev [linux-any],
  libnl-genl-3-dev [linux-any],
  libnl-route-3-dev [linux-any],
- libpcap-dev [kfreebsd-any],
- libbsd-dev [kfreebsd-any],
  libreadline-dev,
  pkgconf | pkg-config,
  docbook-to-man <!nodoc>,
@@ -27,7 +25,7 @@
 Homepage: https://w1.fi/wpa_supplicant/
 
 Package: hostapd
-Architecture: linux-any kfreebsd-any
+Architecture: linux-any
 Multi-Arch: foreign
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends},
@@ -51,7 +49,6 @@
  .
   * mac80211 based drivers with support for master mode [linux]
   * Host AP driver for Prism2/2.5/3 [linux]
-  * Driver interface for FreeBSD net80211 layer [kfreebsd]
   * Any wired Ethernet driver for wired IEEE 802.1X authentication.
 
 Package: wpagui
@@ -69,11 +66,10 @@
  and a method to add or edit wpa_supplicant networks.
 
 Package: wpasupplicant
-Architecture: linux-any kfreebsd-any
+Architecture: linux-any
 Multi-Arch: foreign
 Depends: ${shlibs:Depends},
  ${misc:Depends},
- adduser
 Breaks: network-manager (<< 1.36.4-2~)
 Suggests: wpagui,
  libengine-pkcs11-openssl
@@ -101,7 +97,7 @@
  This is a udeb of wpasupplicant for use by the debian-installer.
 
 Package: eapoltest
-Architecture: linux-any kfreebsd-any
+Architecture: linux-any
 Depends: ${shlibs:Depends},
  ${misc:Depends}
 Description: EAPoL testing utility
@@ -112,7 +108,7 @@
 
 Package: libwpa-client-dev
 Section: libdevel
-Architecture: linux-any kfreebsd-any
+Architecture: linux-any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: libwpa-dev

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=qt5
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

# The build system doesn't use CPPFLAGS, pass them to CFLAGS/CXXFLAGS to
# enable the missing (hardening) flags
DEB_CFLAGS_MAINT_APPEND   = -MMD -Wall $(shell dpkg-buildflags --get CPPFLAGS)
DEB_CXXFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)

include /usr/share/dpkg/default.mk

BINDIR    = /usr/sbin
V = 1

PKG_CONFIG ?= $(DEB_HOST_GNU_TYPE)-pkg-config

export BINDIR V PKG_CONFIG

HOSTAPD_DOT_CONFIG            := debian/config/hostapd/$(DEB_HOST_ARCH_OS)
WPASUPPLICANT_DOT_CONFIG      := debian/config/wpasupplicant/$(DEB_HOST_ARCH_OS)
WPASUPPLICANT_UDEB_DOT_CONFIG := debian/config/wpasupplicant/$(DEB_HOST_ARCH_OS)-udeb

### start dh overrides
override_dh_auto_configure:
ifeq (,$(filter pkg.wpa.nogui,$(DEB_BUILD_PROFILES)))
	dh_auto_configure --sourcedirectory=wpa_supplicant/wpa_gui-qt4 \
	                  --buildsystem=qmake
endif

override_dh_auto_build:
ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
	# build documentation
	dh_auto_build --sourcedirectory=wpa_supplicant/doc/docbook \
	              --buildsystem=makefile \
	              -- man
endif
ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
	# build wpasupplicant-udeb
	cp -v --remove-destination $(WPASUPPLICANT_UDEB_DOT_CONFIG) wpa_supplicant/.config
	dh_auto_build --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile
	mv -v wpa_supplicant/wpa_supplicant wpa_supplicant/wpa_supplicant-udeb
	dh_auto_clean --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile
endif
	# build wpasupplicant, libwpa_client and eapol_test
	cp -v --remove-destination $(WPASUPPLICANT_DOT_CONFIG) wpa_supplicant/.config
	dh_auto_build --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile -- all libwpa_client.a eapol_test
ifeq (,$(filter pkg.wpa.nogui,$(DEB_BUILD_PROFILES)))
	# build wpa_gui-qt4
	dh_auto_build --sourcedirectory=wpa_supplicant/wpa_gui-qt4 \
	              --buildsystem=qmake
endif
	dh_auto_clean --sourcedirectory=src --buildsystem=makefile
	# build hostapd
	cp -v --remove-destination $(HOSTAPD_DOT_CONFIG) hostapd/.config
	dh_auto_build --sourcedirectory=hostapd \
	              --buildsystem=makefile -- ALL="hostapd hostapd_cli nt_password_hash sae_pk_gen"
	dh_auto_clean --sourcedirectory=src --buildsystem=makefile

override_dh_auto_clean:
ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
	dh_auto_clean --sourcedirectory=wpa_supplicant/doc/docbook \
	              --buildsystem=makefile
endif
	dh_auto_clean --sourcedirectory=wpa_supplicant \
	              --buildsystem=makefile
ifeq (,$(filter pkg.wpa.nogui,$(DEB_BUILD_PROFILES)))
	dh_auto_clean --sourcedirectory=wpa_supplicant/wpa_gui-qt4 \
	              --buildsystem=qmake
	-find wpa_supplicant/wpa_gui-qt4 -type d -name \.moc -exec rm -rf {} \;
	-find wpa_supplicant/wpa_gui-qt4 -type d -name \.ui  -exec rm -rf {} \;
	-find wpa_supplicant/wpa_gui-qt4 -type d -name \.obj -exec rm -rf {} \;
endif
	dh_auto_clean --sourcedirectory=hostapd \
	              --buildsystem=makefile

override_dh_auto_install:
	$(info Skip dh_auto_install ...)

execute_before_dh_clean:
	# make sure to remove the staging directory for the udeb
	rm -rf debian/wpasupplicant-udeb

execute_after_dh_install:
	# install D-Bus service activation files & configuration
	install --mode=644 -D wpa_supplicant/dbus/dbus-wpa_supplicant.conf \
		debian/wpasupplicant/usr/share/dbus-1/system.d/wpa_supplicant.conf
ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
	# Install udeb
	install --mode=755 -D wpa_supplicant/wpa_supplicant-udeb \
		debian/wpasupplicant-udeb/usr/sbin/wpa_supplicant
endif

override_dh_installchangelogs:
	dh_installchangelogs --package=hostapd hostapd/ChangeLog
	dh_installchangelogs --package=wpasupplicant wpa_supplicant/ChangeLog
ifeq (,$(filter pkg.wpa.nogui,$(DEB_BUILD_PROFILES)))
	dh_installchangelogs --package=wpagui wpa_supplicant/ChangeLog
endif
	dh_installchangelogs --remaining-packages
### end dh overrides

execute_after_dh_installexamples:
	sed -e 's="includes.h"=<stddef.h>=' -e 's="common/wpa_ctrl.h"=<wpa_ctrl.h>=' -i debian/*/usr/share/doc/*/examples/*.c

%:
	dh $@

=== debian/watch ===
# Find hostapd tarball in http://w1.fi/releases/.
# We need to generate a merged wpa tarball from wpa_supplicant and hostapd,
# so use our own script instead of uupdate.
version=4
#opts=pgpmode=auto http://w1.fi/releases/hostapd-([\.0-9]+)\.tar\.gz debian debian/uscan-hook

opts="mode=git, pgpmode=none, repack, compression=xz" \
 https://git.w1.fi/hostap.git \
 refs/tags/hostap_([\d]+)_([\d]+)

opts="mode=git, pgpmode=none, pretty=2.9.0+git%cd+%h, repack, compression=xz" \
 https://git.w1.fi/hostap.git \
 HEAD

## wpa actiond-1.0

=== Makefile ===
CC = gcc
OBJS = wpa_actiond.o
LINKOBJS = wpa_ctrl/wpa_ctrl.o wpa_ctrl/os_strlcpy.o $(OBJS)
TARGET = wpa_actiond
LIBS =

all: $(TARGET)

wpactrl:
	make -C wpa_ctrl

$(TARGET): wpactrl $(OBJS)
	$(CC) $(LINKOBJS) $(CFLAGS) $(LIBS) -o $(TARGET)

clean:
	make -C wpa_ctrl clean
	rm -f $(OBJS) $(TARGET)

%.o: %.c
	$(CC) -c $(CFLAGS) $< -o $@

## wpa actiond-1.2

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	make -C wpa_ctrl
 
 $(TARGET): wpactrl $(OBJS)
-	$(CC) $(LINKOBJS) $(CFLAGS) $(LIBS) -o $(TARGET)
+	$(CC) $(LINKOBJS) $(CFLAGS) $(LDFLAGS) $(LIBS) -o $(TARGET)
 
 clean:
 	make -C wpa_ctrl clean

## wpa actiond-1.3

=== wpa_ctrl/Makefile ===
OBJS = wpa_ctrl.o os_strlcpy.o
CTRLFLAGS = -DCONFIG_CTRL_IFACE -DCONFIG_CTRL_IFACE_UNIX

all: $(OBJS)

clean:
	rm -f $(OBJS) $(TARGET)

wpa_ctrl.o: common.h os.h wpa_debug.h wpabuf.h includes.h build_config.h wpa_ctrl.h wpa_ctrl.c
os_strlcpy.o: os.h includes.h build_config.h os_strlcpy.c

%.o: %.c
	$(CC) -c $(CFLAGS) $(CTRLFLAGS) $< -o $@

## wpa actiond-1.4

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 CC = gcc
 OBJS = wpa_actiond.o
-LINKOBJS = wpa_ctrl/wpa_ctrl.o wpa_ctrl/os_strlcpy.o $(OBJS)
+LINKOBJS = wpa_ctrl/wpa_ctrl.o wpa_ctrl/os_unix.o $(OBJS)
 TARGET = wpa_actiond
 LIBS =

=== wpa_ctrl/Makefile ===
OBJS = wpa_ctrl.o os_unix.o
CTRLFLAGS = -DCONFIG_CTRL_IFACE -DCONFIG_CTRL_IFACE_UNIX

all: $(OBJS)

clean:
	rm -f $(OBJS) $(TARGET)

wpa_ctrl.o: common.h os.h wpa_debug.h wpabuf.h includes.h build_config.h wpa_ctrl.h wpa_ctrl.c
os_unix.o: os.h includes.h build_config.h os_unix.c

%.o: %.c
	$(CC) -c $(CFLAGS) $(CTRLFLAGS) $< -o $@

## wpa supplicant-0.2.5-src-vl5

=== Makefile ===
ifndef CC
CC=gcc
endif

ifndef CFLAGS
CFLAGS = -MMD -O2 -Wall -g
endif

# Include directories for CVS version
CFLAGS += -I../driver/modules -I../utils -I../hostapd

# Uncomment following two lines and fix the paths if you have installed openssl
# in non-default location
#CFLAGS += -I/usr/local/openssl/include
#LIBS += -L/usr/local/openssl/lib

# Uncomment following two lines to use portable libdnet and libpcap instead of
# Linux-specific internal implementation for L2 packet handling
#CFLAGS += -DUSE_DNET_PCAP
#LIBS=-ldnet -lpcap

all: verify_config wpa_supplicant wpa_passphrase wpa_cli

verify_config:
	@if [ ! -r .config ]; then \
		echo 'Building wpa_supplicant request a configuration file'; \
		echo '(.config). See README for more instructions or run'; \
		echo '"make mkconfig" to create an example configuration.'; \
		exit 1; \
	fi

mkconfig:
	@if [ -e .config ]; then \
		echo '.config exists - did not replace it'; \
		exit 1; \
	fi
	echo CONFIG_DRIVER_HOSTAP=y >> .config
	echo CONFIG_DRIVER_WEXT=y >> .config
	echo CONFIG_WIRELESS_EXTENSION=y >> .config

OBJS = config.o ctrl_iface.o \
	eloop.o common.o md5.o \
	rc4.o sha1.o aes_wrap.o
OBJS_p = wpa_passphrase.o sha1.o
OBJS_c = wpa_cli.o wpa_ctrl.o

-include .config

ifdef CONFIG_EAPOL_TEST
CFLAGS += -Werror -DEAPOL_TEST
endif

ifdef CONFIG_DRIVER_HOSTAP
CFLAGS += -DCONFIG_DRIVER_HOSTAP
OBJS += driver_hostap.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_WEXT
CFLAGS += -DCONFIG_DRIVER_WEXT
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_PRISM54
CFLAGS += -DCONFIG_DRIVER_PRISM54
OBJS += driver_prism54.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_HERMES
CFLAGS += -DCONFIG_DRIVER_HERMES
CFLAGS += -I../../hcf -I../../include -I../../include/hcf
CFLAGS += -I../../include/wireless
OBJS += driver_hermes.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_MADWIFI
CFLAGS += -DCONFIG_DRIVER_MADWIFI
CFLAGS += -I../madwifi/wpa		# change to reflect local setup
OBJS += driver_madwifi.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_ATMEL
CFLAGS += -DCONFIG_DRIVER_ATMEL
OBJS += driver_atmel.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_NDISWRAPPER
CFLAGS += -DCONFIG_DRIVER_NDISWRAPPER
OBJS += driver_ndiswrapper.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_EAP_TLS
# EAP-TLS
CFLAGS += -DEAP_TLS
OBJS += eap_tls.o
TLS_FUNCS=y
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_PEAP
# EAP-PEAP
CFLAGS += -DEAP_PEAP
OBJS += eap_peap.o
TLS_FUNCS=y
CONFIG_MSCHAPV2=y
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_TTLS
# EAP-TTLS
CFLAGS += -DEAP_TTLS
OBJS += eap_ttls.o
MS_FUNCS=y
TLS_FUNCS=y
CONFIG_EAP_MD5=y
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_MD5
# EAP-MD5 (also used by EAP-TTLS)
CFLAGS += -DEAP_MD5
OBJS += eap_md5.o
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_MSCHAPV2
# EAP-MSCHAPv2 (also used by EAP-PEAP)
CFLAGS += -DEAP_MSCHAPv2
OBJS += eap_mschapv2.o
MS_FUNCS=y
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_GTC
# EAP-GTC (also used by EAP-PEAP)
CFLAGS += -DEAP_GTC
OBJS += eap_gtc.o
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_OTP
# EAP-OTP
CFLAGS += -DEAP_OTP
OBJS += eap_otp.o
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_SIM
# EAP-SIM
CFLAGS += -DEAP_SIM
OBJS += eap_sim.o
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_LEAP
# EAP-LEAP
CFLAGS += -DEAP_LEAP
OBJS += eap_leap.o
MS_FUNCS=y
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_IEEE8021X_EAPOL
# IEEE 802.1X/EAPOL state machines (e.g., for RADIUS authentication)
CFLAGS += -DIEEE8021X_EAPOL
OBJS += eapol_sm.o eap.o
endif

ifdef CONFIG_PCSC
# PC/SC interface for smartcards (USIM, GSM SIM)
CFLAGS += -DPCSC_FUNCS
OBJS += pcsc_funcs.o
# -lpthread may not be needed depending on how pcsc-lite was configured
LIBS += -lpcsclite -lpthread
endif

ifdef TLS_FUNCS
# Shared TLS functions (needed for EAP_TLS, EAP_PEAP, and EAP_TTLS)
CFLAGS += -DEAP_TLS_FUNCS
OBJS += eap_tls_common.o
LIBS += -lssl
LIBS_p += -lcrypto
endif

ifdef MS_FUNCS
ifndef TLS_FUNCS
LIBS += -lcrypto
endif
OBJS += ms_funcs.o
endif

ifdef CONFIG_WIRELESS_EXTENSION
CFLAGS += -DCONFIG_WIRELESS_EXTENSION
OBJS += driver_wext.o
endif

OBJS_t := $(OBJS) eapol_test.o radius.o radius_client.o
OBJS += wpa_supplicant.o wpa.o l2_packet.o

wpa_supplicant: .config $(OBJS)
	$(CC) -o wpa_supplicant $(OBJS) $(LIBS)

eapol_test: .config $(OBJS_t)
	$(CC) -o eapol_test $(OBJS_t) $(LIBS)

wpa_passphrase: $(OBJS_p)
	$(CC) -o wpa_passphrase $(OBJS_p) $(LIBS_p)

wpa_cli: $(OBJS_c)
	$(CC) -o wpa_cli $(OBJS_c)

clean:
	rm -f core *~ *.o wpa_supplicant wpa_passphrase wpa_cli *.d

-include $(OBJS:%.o=%.d)

## wpa supplicant-0.4.7

=== Makefile ===
ifndef CC
CC=gcc
endif

ifndef CFLAGS
CFLAGS = -MMD -O2 -Wall -g
endif

# Include directories for CVS version
CFLAGS += -I. -I../utils -I../hostapd

ALL=wpa_supplicant wpa_passphrase wpa_cli

all: verify_config $(ALL)

verify_config:
	@if [ ! -r .config ]; then \
		echo 'Building wpa_supplicant requires a configuration file'; \
		echo '(.config). See README for more instructions. You can'; \
		echo 'run "cp defconfig .config" to create an example'; \
		echo 'configuration.'; \
		exit 1; \
	fi

mkconfig:
	@if [ -e .config ]; then \
		echo '.config exists - did not replace it'; \
		exit 1; \
	fi
	echo CONFIG_DRIVER_HOSTAP=y >> .config
	echo CONFIG_DRIVER_WEXT=y >> .config
	echo CONFIG_WIRELESS_EXTENSION=y >> .config

install: all
	mkdir -p $(DESTDIR)/usr/local/sbin/
	for i in $(ALL); do cp $$i $(DESTDIR)/usr/local/sbin/$$i; done

OBJS = config.o \
	eloop.o common.o md5.o \
	rc4.o sha1.o
OBJS_p = wpa_passphrase.o sha1.o md5.o
OBJS_c = wpa_cli.o wpa_ctrl.o

-include .config

ifdef CONFIG_EAPOL_TEST
CFLAGS += -Werror -DEAPOL_TEST
endif

ifndef CONFIG_BACKEND
CONFIG_BACKEND=file
endif

ifeq ($(CONFIG_BACKEND), file)
OBJS += config_file.o base64.o
endif

ifdef CONFIG_DRIVER_HOSTAP
CFLAGS += -DCONFIG_DRIVER_HOSTAP
OBJS_d += driver_hostap.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_WEXT
CFLAGS += -DCONFIG_DRIVER_WEXT
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_PRISM54
CFLAGS += -DCONFIG_DRIVER_PRISM54
OBJS_d += driver_prism54.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_HERMES
CFLAGS += -DCONFIG_DRIVER_HERMES
OBJS_d += driver_hermes.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_MADWIFI
CFLAGS += -DCONFIG_DRIVER_MADWIFI
OBJS_d += driver_madwifi.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_ATMEL
CFLAGS += -DCONFIG_DRIVER_ATMEL
OBJS_d += driver_atmel.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_NDISWRAPPER
CFLAGS += -DCONFIG_DRIVER_NDISWRAPPER
OBJS_d += driver_ndiswrapper.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_BROADCOM
CFLAGS += -DCONFIG_DRIVER_BROADCOM
OBJS_d += driver_broadcom.o
endif

ifdef CONFIG_DRIVER_IPW
CFLAGS += -DCONFIG_DRIVER_IPW
OBJS_d += driver_ipw.o
CONFIG_WIRELESS_EXTENSION=y
endif

ifdef CONFIG_DRIVER_BSD
CFLAGS += -DCONFIG_DRIVER_BSD
OBJS_d += driver_bsd.o
CONFIG_DNET_PCAP=y
CONFIG_L2_FREEBSD=y
endif

ifdef CONFIG_DRIVER_NDIS
CFLAGS += -DCONFIG_DRIVER_NDIS
OBJS_d += driver_ndis.o driver_ndis_.o
CONFIG_DNET_PCAP=y
CONFIG_WINPCAP=y
endif

ifdef CONFIG_DRIVER_WIRED
CFLAGS += -DCONFIG_DRIVER_WIRED
OBJS_d += driver_wired.o
endif

ifdef CONFIG_DRIVER_TEST
CFLAGS += -DCONFIG_DRIVER_TEST
OBJS_d += driver_test.o
endif

ifdef CONFIG_DNET_PCAP
CFLAGS += -DUSE_DNET_PCAP
ifdef CONFIG_WINPCAP
OBJS += l2_packet_pcap.o
CFLAGS += -DCONFIG_WINPCAP
LIBS += -lwpcap -lpacket
LIBS_w += -lwpcap
else
ifdef CONFIG_L2_FREEBSD
OBJS += l2_packet_freebsd.o
LIBS += -lpcap
else
OBJS += l2_packet_pcap.o
LIBS += -ldnet -lpcap
endif
endif
else
OBJS += l2_packet_linux.o
endif

ifdef CONFIG_EAP_TLS
# EAP-TLS
CFLAGS += -DEAP_TLS
OBJS += eap_tls.o
TLS_FUNCS=y
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_PEAP
# EAP-PEAP
CFLAGS += -DEAP_PEAP
OBJS += eap_peap.o
TLS_FUNCS=y
CONFIG_EAP_MSCHAPV2=y
CONFIG_IEEE8021X_EAPOL=y
CONFIG_EAP_TLV=y
endif

ifdef CONFIG_EAP_TTLS
# EAP-TTLS
CFLAGS += -DEAP_TTLS
OBJS += eap_ttls.o
MS_FUNCS=y
TLS_FUNCS=y
CONFIG_EAP_MD5=y
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_MD5
# EAP-MD5 (also used by EAP-TTLS)
CFLAGS += -DEAP_MD5
OBJS += eap_md5.o
CONFIG_IEEE8021X_EAPOL=y
endif

# backwards compatibility for old spelling
ifdef CONFIG_MSCHAPV2
CONFIG_EAP_MSCHAPV2=y
endif

ifdef CONFIG_EAP_MSCHAPV2
# EAP-MSCHAPv2 (also used by EAP-PEAP)
CFLAGS += -DEAP_MSCHAPv2
OBJS += eap_mschapv2.o
MS_FUNCS=y
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_GTC
# EAP-GTC (also used by EAP-PEAP)
CFLAGS += -DEAP_GTC
OBJS += eap_gtc.o
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_OTP
# EAP-OTP
CFLAGS += -DEAP_OTP
OBJS += eap_otp.o
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_SIM
# EAP-SIM
CFLAGS += -DEAP_SIM
OBJS += eap_sim.o
CONFIG_IEEE8021X_EAPOL=y
CONFIG_EAP_SIM_COMMON=y
endif

ifdef CONFIG_EAP_LEAP
# EAP-LEAP
CFLAGS += -DEAP_LEAP
OBJS += eap_leap.o
MS_FUNCS=y
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_EAP_PSK
# EAP-PSK
CFLAGS += -DEAP_PSK
OBJS += eap_psk.o eap_psk_common.o
CONFIG_IEEE8021X_EAPOL=y
NEED_AES=y
endif

ifdef CONFIG_EAP_AKA
# EAP-AKA
CFLAGS += -DEAP_AKA
OBJS += eap_aka.o
CONFIG_IEEE8021X_EAPOL=y
CONFIG_EAP_SIM_COMMON=y
endif

ifdef CONFIG_EAP_SIM_COMMON
OBJS += eap_sim_common.o
NEED_AES=y
endif

ifdef CONFIG_EAP_TLV
# EAP-TLV
CFLAGS += -DEAP_TLV
OBJS += eap_tlv.o
endif

ifdef CONFIG_EAP_FAST
# EAP-FAST
CFLAGS += -DEAP_FAST
OBJS += eap_fast.o
TLS_FUNCS=y
endif

ifdef CONFIG_EAP_PAX
# EAP-PAX
CFLAGS += -DEAP_PAX
OBJS += eap_pax.o eap_pax_common.o
CONFIG_IEEE8021X_EAPOL=y
endif

ifdef CONFIG_IEEE8021X_EAPOL
# IEEE 802.1X/EAPOL state machines (e.g., for RADIUS authentication)
CFLAGS += -DIEEE8021X_EAPOL
OBJS += eapol_sm.o eap.o
endif

ifdef CONFIG_PCSC
# PC/SC interface for smartcards (USIM, GSM SIM)
CFLAGS += -DPCSC_FUNCS -I/usr/include/PCSC
OBJS += pcsc_funcs.o
# -lpthread may not be needed depending on how pcsc-lite was configured
LIBS += -lpcsclite -lpthread
endif

ifndef CONFIG_TLS
CONFIG_TLS=openssl
endif

ifdef TLS_FUNCS
# Shared TLS functions (needed for EAP_TLS, EAP_PEAP, EAP_TTLS, and EAP_FAST)
CFLAGS += -DEAP_TLS_FUNCS
OBJS += eap_tls_common.o
ifeq ($(CONFIG_TLS), openssl)
OBJS += tls_openssl.o
LIBS += -lssl -lcrypto
LIBS_p += -lcrypto
endif
ifeq ($(CONFIG_TLS), gnutls)
OBJS += tls_gnutls.o
LIBS += -lgnutls -lgcrypt -lgpg-error
LIBS_p += -lgcrypt
endif
ifeq ($(CONFIG_TLS), schannel)
OBJS += tls_schannel.o
# Using OpenSSL for crypto at the moment; to be replaced
LIBS += -lcrypto
LIBS_p += -lcrypto
endif
ifdef CONFIG_SMARTCARD
ifndef CONFIG_NATIVE_WINDOWS
ifndef CONFIG_L2_FREEBSD
LIBS += -ldl
endif
endif
endif
NEED_CRYPTO=y
else
OBJS += tls_none.o
endif

ifdef CONFIG_PKCS12
CFLAGS += -DPKCS12_FUNCS
endif

ifdef CONFIG_SMARTCARD
CFLAGS += -DCONFIG_SMARTCARD
endif

ifdef MS_FUNCS
OBJS += ms_funcs.o
NEED_CRYPTO=y
endif

ifdef NEED_CRYPTO
ifndef TLS_FUNCS
ifeq ($(CONFIG_TLS), openssl)
LIBS += -lcrypto
LIBS_p += -lcrypto
endif
ifeq ($(CONFIG_TLS), gnutls)
LIBS += -lgcrypt
LIBS_p += -lgcrypt
endif
ifeq ($(CONFIG_TLS), schannel)
# Using OpenSSL for crypto at the moment; to be replaced
LIBS += -lcrypto
LIBS_p += -lcrypto
endif
endif
ifeq ($(CONFIG_TLS), openssl)
OBJS += crypto.o
OBJS_p += crypto.o
endif
ifeq ($(CONFIG_TLS), gnutls)
OBJS += crypto_gnutls.o
OBJS_p += crypto_gnutls.o
endif
ifeq ($(CONFIG_TLS), schannel)
# Using OpenSSL for crypto at the moment; to be replaced
OBJS += crypto.o
OBJS_p += crypto.o
endif
endif

ifdef CONFIG_WIRELESS_EXTENSION
CFLAGS += -DCONFIG_WIRELESS_EXTENSION
OBJS_d += driver_wext.o
endif

ifdef CONFIG_CTRL_IFACE
CFLAGS += -DCONFIG_CTRL_IFACE
OBJS += ctrl_iface.o
endif

ifdef CONFIG_READLINE
CFLAGS += -DCONFIG_READLINE
LIBS_c += -lncurses -lreadline
endif

ifdef CONFIG_NATIVE_WINDOWS
CFLAGS += -DCONFIG_NATIVE_WINDOWS -DCONFIG_CTRL_IFACE_UDP
LIBS += -lws2_32 -lgdi32 -lcrypt32
LIBS_c += -lws2_32
endif

ifdef CONFIG_NO_STDOUT_DEBUG
CFLAGS += -DCONFIG_NO_STDOUT_DEBUG
endif

ifdef CONFIG_IPV6
# for eapol_test only
CFLAGS += -DCONFIG_IPV6
endif

ifndef CONFIG_NO_WPA
OBJS += wpa.o preauth.o
NEED_AES=y
else
CFLAGS += -DCONFIG_NO_WPA
endif

ifdef NEED_AES
OBJS += aes_wrap.o
endif

OBJS += wpa_supplicant.o events.o
OBJS_t := $(OBJS) eapol_test.o radius.o radius_client.o
OBJS_t2 := $(OBJS) preauth_test.o
OBJS += main.o drivers.o $(OBJS_d)

wpa_supplicant: .config $(OBJS)
	$(CC) -o wpa_supplicant $(OBJS) $(LIBS)

eapol_test: .config $(OBJS_t)
	$(CC) -o eapol_test $(OBJS_t) $(LIBS)

preauth_test: .config $(OBJS_t2) 
	$(CC) -o preauth_test $(OBJS_t2) $(LIBS)

wpa_passphrase: $(OBJS_p)
	$(CC) -o wpa_passphrase $(OBJS_p) $(LIBS_p)

wpa_cli: $(OBJS_c)
	$(CC) -o wpa_cli $(OBJS_c) $(LIBS_c)

win_if_list: win_if_list.c
	$(CC) -o $@ win_if_list.c $(CFLAGS) $(LIBS_w)

# parameters for Microsoft Visual C++ Toolkit 2003 compiler
CL=cl
CLDIR=C:\Program Files\Microsoft Visual C++ Toolkit 2003
PSDKDIR=C:\Program Files\Microsoft Platform SDK for Windows XP SP2
CLFLAGS=-O
CLLIBS=wbemuuid.lib libcmt.lib kernel32.lib uuid.lib ole32.lib oleaut32.lib \
	ws2_32.lib

ndis_events: ndis_events.cpp
	INCLUDE="$(CLDIR)\include;$(PSDKDIR)\Include" \
	LIB="$(CLDIR)\lib;$(PSDKDIR)\Lib" \
	$(CL) $(CLFLAGS) -o ndis_events.exe ndis_events.cpp \
		/link -nodefaultlib $(CLLIBS)

wpa_supplicant.exe: wpa_supplicant
	mv -f $< $@
wpa_cli.exe: wpa_cli
	mv -f $< $@
wpa_passphrase.exe: wpa_passphrase
	mv -f $< $@
win_if_list.exe: win_if_list
	mv -f $< $@
eapol_test.exe: eapol_test
	mv -f $< $@

WINALL=wpa_supplicant.exe wpa_cli.exe wpa_passphrase.exe win_if_list.exe

windows-bin: $(WINALL)
	$(STRIP) $(WINALL)

wpa_gui/Makefile:
	qmake -o wpa_gui/Makefile wpa_gui/wpa_gui.pro 

wpa_gui: wpa_gui/Makefile
	$(MAKE) -C wpa_gui

TEST_SRC_MS_FUNCS = ms_funcs.c crypto.c sha1.c md5.c
test-ms_funcs: $(TEST_SRC_MS_FUNCS)
	$(CC) -o test-ms_funcs -Wall -Werror $(TEST_SRC_MS_FUNCS) \
		-DTEST_MAIN_MS_FUNCS -lcrypto -I../hostapd -I.
	./test-ms_funcs
	rm test-ms_funcs

TEST_SRC_SHA1 = sha1.c
test-sha1: $(TEST_SRC_SHA1)
	$(CC) -o test-sha1 -Wall -Werror $(TEST_SRC_SHA1) \
		-DTEST_MAIN -I../hostad -I.
	./test-sha1
	rm test-sha1

TEST_SRC_AES_WRAP = aes_wrap.c
test-aes_wrap: $(TEST_SRC_AES_WRAP)
	$(CC) -o test-aes_wrap -Wall -Werror $(TEST_SRC_AES_WRAP) \
		-DTEST_MAIN -I../hostad -I.
	./test-aes_wrap
	rm test-aes_wrap

TEST_SRC_EAP_SIM_COMMON = eap_sim_common.c sha1.c md5.c \
	aes_wrap.c common.c
test-eap_sim_common: $(TEST_SRC_EAP_SIM_COMMON)
	$(CC) -o test-eap_sim_common -Wall -Werror $(TEST_SRC_EAP_SIM_COMMON) \
		-DTEST_MAIN_EAP_SIM_COMMON -I../hostapd -I.
	./test-eap_sim_common
	rm test-eap_sim_common

tests: test-ms_funcs test-sha1 test-aes_wrap test-eap_sim_common

clean:
	rm -f core *~ *.o *.d $(ALL) $(WINALL)

%.eps: %.fig
	fig2dev -L eps $*.fig $*.eps

%.png: %.fig
	fig2dev -L png -m 3 $*.fig | pngtopnm | pnmscale 0.4 | pnmtopng \
		> $*.png

docs-pics: doc/wpa_supplicant.png doc/wpa_supplicant.eps

docs: docs-pics
	doxygen doc/doxygen.full
	$(MAKE) -C doc/latex
	cp doc/latex/refman.pdf wpa_supplicant-devel.pdf

docs-fast: docs-pics
	doxygen doc/doxygen.fast

clean-docs:
	rm -rf doc/latex doc/html
	rm -f doc/wpa_supplicant.{eps,png} wpa_supplicant-devel.pdf

-include $(OBJS:%.o=%.d)

## wpa supplicant-0.4.9

=== doc/docbook/Makefile ===
all: man html pdf

FILES += wpa_background
FILES += wpa_cli
FILES += wpa_passphrase
FILES += wpa_supplicant.conf
FILES += wpa_supplicant

man:
	for i in $(FILES); do docbook2man $$i.sgml; done

html:
	for i in $(FILES); do docbook2html $$i.sgml && \
		mv index.html $$i.html; done

pdf:
	for i in $(FILES); do docbook2pdf $$i.sgml; done


clean:
	rm -f wpa_background.8 wpa_cli.8 wpa_passphrase.8 wpa_supplicant.8
	rm -f wpa_supplicant.conf.5
	rm -f manpage.links manpage.refs
	rm -f $(FILES:%=%.pdf)
	rm -f $(FILES:%=%.html)

## wpa supplicant-0.5.1

=== Makefile ===
--- 
+++ 
@@ -36,13 +36,31 @@
 	for i in $(ALL); do cp $$i $(DESTDIR)/usr/local/sbin/$$i; done
 
 OBJS = config.o \
-	eloop.o common.o md5.o \
+	common.o md5.o \
 	rc4.o sha1.o
 OBJS_p = wpa_passphrase.o sha1.o md5.o
 OBJS_c = wpa_cli.o wpa_ctrl.o
 
 -include .config
 
+ifndef CONFIG_OS
+ifdef CONFIG_NATIVE_WINDOWS
+CONFIG_OS=win32
+else
+CONFIG_OS=unix
+endif
+endif
+
+OBJS += os_$(CONFIG_OS).o
+OBJS_p += os_$(CONFIG_OS).o
+OBJS_c += os_$(CONFIG_OS).o
+
+ifndef CONFIG_ELOOP
+CONFIG_ELOOP=eloop
+endif
+OBJS += $(CONFIG_ELOOP).o
+
+
 ifdef CONFIG_EAPOL_TEST
 CFLAGS += -Werror -DEAPOL_TEST
 endif
@@ -53,6 +71,15 @@
 
 ifeq ($(CONFIG_BACKEND), file)
 OBJS += config_file.o base64.o
+CFLAGS += -DCONFIG_BACKEND_FILE
+endif
+
+ifeq ($(CONFIG_BACKEND), winreg)
+OBJS += config_winreg.o
+endif
+
+ifeq ($(CONFIG_BACKEND), none)
+OBJS += config_none.o
 endif
 
 ifdef CONFIG_DRIVER_HOSTAP
@@ -110,14 +137,17 @@
 ifdef CONFIG_DRIVER_BSD
 CFLAGS += -DCONFIG_DRIVER_BSD
 OBJS_d += driver_bsd.o
-CONFIG_DNET_PCAP=y
-CONFIG_L2_FREEBSD=y
+ifndef CONFIG_L2_PACKET
+CONFIG_L2_PACKET=freebsd
+endif
 endif
 
 ifdef CONFIG_DRIVER_NDIS
 CFLAGS += -DCONFIG_DRIVER_NDIS
 OBJS_d += driver_ndis.o driver_ndis_.o
-CONFIG_DNET_PCAP=y
+ifndef CONFIG_L2_PACKET
+CONFIG_L2_PACKET=pcap
+endif
 CONFIG_WINPCAP=y
 endif
 
@@ -131,24 +161,29 @@
 OBJS_d += driver_test.o
 endif
 
-ifdef CONFIG_DNET_PCAP
-CFLAGS += -DUSE_DNET_PCAP
+ifndef CONFIG_L2_PACKET
+CONFIG_L2_PACKET=linux
+endif
+
+OBJS += l2_packet_$(CONFIG_L2_PACKET).o
+
+ifeq ($(CONFIG_L2_PACKET), pcap)
 ifdef CONFIG_WINPCAP
-OBJS += l2_packet_pcap.o
 CFLAGS += -DCONFIG_WINPCAP
 LIBS += -lwpcap -lpacket
 LIBS_w += -lwpcap
 else
-ifdef CONFIG_L2_FREEBSD
-OBJS += l2_packet_freebsd.o
+LIBS += -ldnet -lpcap
+endif
+endif
+
+ifeq ($(CONFIG_L2_PACKET), winpcap)
+LIBS += -lwpcap -lpacket
+LIBS_w += -lwpcap
+endif
+
+ifeq ($(CONFIG_L2_PACKET), freebsd)
 LIBS += -lpcap
-else
-OBJS += l2_packet_pcap.o
-LIBS += -ldnet -lpcap
-endif
-endif
-else
-OBJS += l2_packet_linux.o
 endif
 
 ifdef CONFIG_EAP_TLS
@@ -270,6 +305,12 @@
 CONFIG_IEEE8021X_EAPOL=y
 endif
 
+ifdef CONFIG_EAP_VENDOR_TEST
+CFLAGS += -DEAP_VENDOR_TEST
+OBJS += eap_vendor_test.o
+CONFIG_IEEE8021X_EAPOL=y
+endif
+
 ifdef CONFIG_IEEE8021X_EAPOL
 # IEEE 802.1X/EAPOL state machines (e.g., for RADIUS authentication)
 CFLAGS += -DIEEE8021X_EAPOL
@@ -281,7 +322,13 @@
 CFLAGS += -DPCSC_FUNCS -I/usr/include/PCSC
 OBJS += pcsc_funcs.o
 # -lpthread may not be needed depending on how pcsc-lite was configured
+ifdef CONFIG_NATIVE_WINDOWS
+#Once MinGW gets support for WinScard, -lwinscard could be used instead of the
+#dynamic symbol loading that is now used in pcsc_funcs.c
+#LIBS += -lwinscard
+else
 LIBS += -lpcsclite -lpthread
+endif
 endif
 
 ifndef CONFIG_TLS
@@ -293,6 +340,7 @@
 CFLAGS += -DEAP_TLS_FUNCS
 OBJS += eap_tls_common.o
 ifeq ($(CONFIG_TLS), openssl)
+CFLAGS += -DEAP_TLS_OPENSSL
 OBJS += tls_openssl.o
 LIBS += -lssl -lcrypto
 LIBS_p += -lcrypto
@@ -301,16 +349,25 @@
 OBJS += tls_gnutls.o
 LIBS += -lgnutls -lgcrypt -lgpg-error
 LIBS_p += -lgcrypt
+ifdef CONFIG_GNUTLS_EXTRA
+CFLAGS += -DCONFIG_GNUTLS_EXTRA
+LIBS += -lgnutls-extra
+endif
 endif
 ifeq ($(CONFIG_TLS), schannel)
 OBJS += tls_schannel.o
 # Using OpenSSL for crypto at the moment; to be replaced
+CFLAGS += -DEAP_TLS_OPENSSL
 LIBS += -lcrypto
 LIBS_p += -lcrypto
 endif
+ifeq ($(CONFIG_TLS), none)
+OBJS += tls_none.o
+CFLAGS += -DEAP_TLS_NONE
+endif
 ifdef CONFIG_SMARTCARD
 ifndef CONFIG_NATIVE_WINDOWS
-ifndef CONFIG_L2_FREEBSD
+ifneq ($(CONFIG_L2_PACKET), freebsd)
 LIBS += -ldl
 endif
 endif
@@ -362,6 +419,10 @@
 OBJS += crypto.o
 OBJS_p += crypto.o
 endif
+ifeq ($(CONFIG_TLS), none)
+OBJS += crypto_none.o
+OBJS_p += crypto_none.o
+endif
 endif
 
 ifdef CONFIG_WIRELESS_EXTENSION
@@ -370,8 +431,18 @@
 endif
 
 ifdef CONFIG_CTRL_IFACE
+ifeq ($(CONFIG_CTRL_IFACE), y)
+ifdef CONFIG_NATIVE_WINDOWS
+CONFIG_CTRL_IFACE=udp
+else
+CONFIG_CTRL_IFACE=unix
+endif
+endif
 CFLAGS += -DCONFIG_CTRL_IFACE
-OBJS += ctrl_iface.o
+ifeq ($(CONFIG_CTRL_IFACE), udp)
+CFLAGS += -DCONFIG_CTRL_IFACE_UDP
+endif
+OBJS += ctrl_iface.o ctrl_iface_$(CONFIG_CTRL_IFACE).o
 endif
 
 ifdef CONFIG_READLINE
@@ -380,9 +451,10 @@
 endif
 
 ifdef CONFIG_NATIVE_WINDOWS
-CFLAGS += -DCONFIG_NATIVE_WINDOWS -DCONFIG_CTRL_IFACE_UDP
+CFLAGS += -DCONFIG_NATIVE_WINDOWS
 LIBS += -lws2_32 -lgdi32 -lcrypt32
 LIBS_c += -lws2_32
+LIBS_p += -lws2_32
 endif
 
 ifdef CONFIG_NO_STDOUT_DEBUG
@@ -394,8 +466,13 @@
 CFLAGS += -DCONFIG_IPV6
 endif
 
+ifdef CONFIG_STAKEY
+# for eapol_test only
+CFLAGS += -DCONFIG_STAKEY
+endif
+
 ifndef CONFIG_NO_WPA
-OBJS += wpa.o preauth.o
+OBJS += wpa.o preauth.o pmksa_cache.o
 NEED_AES=y
 else
 CFLAGS += -DCONFIG_NO_WPA
@@ -405,28 +482,47 @@
 OBJS += aes_wrap.o
 endif
 
+ifndef CONFIG_MAIN
+CONFIG_MAIN=main
+endif
+
 OBJS += wpa_supplicant.o events.o
 OBJS_t := $(OBJS) eapol_test.o radius.o radius_client.o
 OBJS_t2 := $(OBJS) preauth_test.o
-OBJS += main.o drivers.o $(OBJS_d)
+OBJS += $(CONFIG_MAIN).o drivers.o $(OBJS_d)
+
+ifdef CONFIG_NDIS_EVENTS_INTEGRATED
+CFLAGS += -DCONFIG_NDIS_EVENTS_INTEGRATED
+OBJS += ndis_events.o
+EXTRALIBS += -loleaut32 -lole32 -luuid
+ifdef PLATFORMSDKLIB
+EXTRALIBS += $(PLATFORMSDKLIB)/WbemUuid.Lib
+else
+EXTRALIBS += WbemUuid.Lib
+endif
+endif
+
+ifndef LDO
+LDO=$(CC)
+endif
 
 wpa_supplicant: .config $(OBJS)
-	$(CC) -o wpa_supplicant $(OBJS) $(LIBS)
+	$(LDO) $(LDFLAGS) -o wpa_supplicant $(OBJS) $(LIBS) $(EXTRALIBS)
 
 eapol_test: .config $(OBJS_t)
-	$(CC) -o eapol_test $(OBJS_t) $(LIBS)
+	$(LDO) $(LDFLAGS) -o eapol_test $(OBJS_t) $(LIBS)
 
 preauth_test: .config $(OBJS_t2) 
-	$(CC) -o preauth_test $(OBJS_t2) $(LIBS)
+	$(LDO) $(LDFLAGS) -o preauth_test $(OBJS_t2) $(LIBS)
 
 wpa_passphrase: $(OBJS_p)
-	$(CC) -o wpa_passphrase $(OBJS_p) $(LIBS_p)
+	$(LDO) $(LDFLAGS) -o wpa_passphrase $(OBJS_p) $(LIBS_p)
 
 wpa_cli: $(OBJS_c)
-	$(CC) -o wpa_cli $(OBJS_c) $(LIBS_c)
+	$(LDO) $(LDFLAGS) -o wpa_cli $(OBJS_c) $(LIBS_c)
 
 win_if_list: win_if_list.c
-	$(CC) -o $@ win_if_list.c $(CFLAGS) $(LIBS_w)
+	$(LDO) $(LDFLAGS) -o $@ win_if_list.c $(CFLAGS) $(LIBS_w)
 
 # parameters for Microsoft Visual C++ Toolkit 2003 compiler
 CL=cl
@@ -486,7 +582,7 @@
 	rm test-aes_wrap
 
 TEST_SRC_EAP_SIM_COMMON = eap_sim_common.c sha1.c md5.c \
-	aes_wrap.c common.c
+	aes_wrap.c common.c os_unix.c
 test-eap_sim_common: $(TEST_SRC_EAP_SIM_COMMON)
 	$(CC) -o test-eap_sim_common -Wall -Werror $(TEST_SRC_EAP_SIM_COMMON) \
 		-DTEST_MAIN_EAP_SIM_COMMON -I../hostapd -I.
@@ -505,18 +601,3 @@
 	fig2dev -L png -m 3 $*.fig | pngtopnm | pnmscale 0.4 | pnmtopng \
 		> $*.png
 
-docs-pics: doc/wpa_supplicant.png doc/wpa_supplicant.eps
-
-docs: docs-pics
-	doxygen doc/doxygen.full
-	$(MAKE) -C doc/latex
-	cp doc/latex/refman.pdf wpa_supplicant-devel.pdf
-
-docs-fast: docs-pics
-	doxygen doc/doxygen.fast
-
-clean-docs:
-	rm -rf doc/latex doc/html
-	rm -f doc/wpa_supplicant.{eps,png} wpa_supplicant-devel.pdf
-
--include $(OBJS:%.o=%.d)
